QuickBooks: Full update a credit memo
QuickBooks creditmemo.update: arguments, response, policy and SDK examples.
← creditmemo operations · Get started · OpenAPI downloads
Contract 2026-10-20 · Operation quickbooks.creditmemo.full_update_a_credit_memo
Provider route: POST /v3/company/{realmID}/creditmemo. Alter supplies the connection’s credentials and routing.
Call through Alter
Section titled “Call through Alter”Install @alter-ai/sdk @alter-ai/quickbooks with npm, or alter-sdk-quickbooks with pip. Supply your connected customer’s grant ID and the arguments described below.
import { App } from "@alter-ai/sdk";import { QuickBooksIntegration } from "@alter-ai/quickbooks";
async function execute(input: Parameters<QuickBooksIntegration["creditmemo"]["update"]>[0]) { const app = new App({ apiKey: process.env.ALTER_API_KEY! }); try { const provider = new QuickBooksIntegration(app, { grantId: process.env.PROVIDER_GRANT_ID! }); const call = await provider.creditmemo.update(input); const result = await call.wait(); return result.bodyJson(); } finally { await app.close(); }}import osfrom alter_sdk import Appfrom alter_sdk_quickbooks import QuickBooksIntegration
async def execute(arguments): async with App(api_key=os.environ["ALTER_API_KEY"]) as app: provider = QuickBooksIntegration(app, {"grant_id": os.environ["PROVIDER_GRANT_ID"]}) call = await provider.creditmemo.update(arguments) result = await call.wait() return result.body_json()| Field | Type | Presence | Description and constraints |
|---|---|---|---|
$ | object | Root | Additional keys: not allowed |
query | object | Optional | Additional keys: not allowed |
query.minorversion | integer | Optional | Must equal: 75 |
query.requestid | string | Optional | Minimum length: 1 |
body | object | Required within parent | Fields not accepted: sparse Additional keys: not allowed |
body.ApplyTaxAfterDiscount | JSON | Optional | If false or null, calculate the sales tax first, and then apply the discount. If true, subtract the discount first and then calculate the sales tax. US versions of QuickBooks only. |
body.ApplyTaxAfterDiscount (anyOf 1) | boolean | Alternative | |
body.ApplyTaxAfterDiscount (anyOf 2) | string | Alternative | One of: true, false |
body.Balance | JSON | Optional | The balance reflecting any payments made against the transaction. Initially set to the value of TotalAmt . A Balance of 0 indicates the invoice is fully paid. Calculated by QuickBooks business logic; any value you supply is over-written by QuickBooks. Decimal string Read only: true |
body.Balance (anyOf 1) | number | Alternative | |
body.Balance (anyOf 2) | string | Alternative | Pattern: ^-?[0-9]+(?:.[0-9]+)?$ |
body.BillAddr | Model | Optional | Expand Create a vendor — request body — body Bill Addr Bill-to address of the credit memo. If BillAddr is not specified, and a default Customer:BillingAddr is specified in QuickBooks for this customer, the default bill-to address is used by QuickBooks. For international addresses - countries should be passed as 3 ISO alpha-3 characters or the full name of the country. If a physical address is updated from within the transaction object, the QuickBooks Online API flows individual address components differently into the Line elements of the transaction response then when the transaction was first created: Line1 and Line2 elements are populated with the customer name and company name. Original Line1 through Line 5 contents, City , SubDivisionCode , and PostalCode flow into Line3 through Line5 as a free format strings. |
body.BillEmail | Model | Optional | Expand Full update companyinfo — request body — body Email Identifies the e-mail address where the credit-memo is sent. If EmailStatus=NeedToSend , BillEmail is a required input. Conditionally required |
body.ClassRef | Model | Optional | Expand Create a purchase order — request body — body Ship To Reference to the Class associated with the transaction. Available if Preferences.AccountingInfoPrefs.ClassTrackingPerLine is set to true . Query the Class name list resource to determine the appropriate Class object for this reference. Use Class.Id and Class.Name from that object for ClassRef.value and ClassRef.name , respectively. |
body.CurrencyRef | Model | Optional | Expand Create a bill — request body — body Currency Ref Reference to the currency in which all amounts on the associated transaction are expressed. This must be defined if multicurrency is enabled for the company. Multicurrency is enabled for the company if Preferences.MultiCurrencyEnabled is set to true . Read more about multicurrency support here . Required if multicurrency is enabled for the company. Conditionally required |
body.CustomField | array | Optional | One of, up to three custom fields for the transaction. Available for custom fields so configured for the company. Check Preferences.SalesFormsPrefs.CustomField and Preferences.VendorAndPurchasesPrefs.POCustomField for custom fields currenly configured. Click here to learn about managing custom fields. |
body.CustomField[] | Model | Each item | Expand Void an invoice — request body — body Custom Field item |
body.CustomerMemo | Model | Optional | Expand Void an invoice — request body — body Customer Memo User-entered message to the customer; this message is visible to end user on their transactions. |
body.CustomerRef | Model | Optional | Expand Create a purchase order — request body — body Ship To Reference to a customer or job. Query the Customer name list resource to determine the appropriate Customer object for this reference. Use Customer.Id and Customer.DisplayName from that object for CustomerRef.value and CustomerRef.name , respectively. |
body.DepartmentRef | Model | Optional | Expand Create a purchase order — request body — body Ship To A reference to a Department object specifying the location of the transaction. Available if Preferences.AccountingInfoPrefs.TrackDepartments is set to true . Query the Department name list resource to determine the appropriate department object for this reference. Use Department.Id and Department.Name from that object for DepartmentRef.value and DepartmentRef.name , respectively. |
body.DocNumber | string | Optional | Reference number for the transaction. If not explicitly provided at create time, this field is populated based on the setting of Preferences:CustomTxnNumber as follows: If Preferences:CustomTxnNumber is true a custom value can be provided. If no value is supplied, the resulting DocNumber is null. If Preferences:CustomTxnNumber is false, resulting DocNumber is system generated by incrementing the last number by 1. If Preferences:CustomTxnNumber is false then do not send a value as it can lead to unwanted duplicates. If a DocNumber value is sent for an Update operation, then it just updates that particular invoice and does not alter the internal system DocNumber. Note: DocNumber is an optional field for all locales except France. For France locale if Preferences:CustomTxnNumber is enabled it will not be automatically generated and is a required field. |
body.EmailStatus | string | Optional | Email status of the credit-memo. Valid values: NotSet , NeedToSend , EmailSent |
body.ExchangeRate | JSON | Optional | The number of home currency units it takes to equal one unit of currency specified by CurrencyRef . Applicable if multicurrency is enabled for the company. Decimal string |
body.ExchangeRate (anyOf 1) | number | Alternative | |
body.ExchangeRate (anyOf 2) | string | Alternative | Pattern: ^-?[0-9]+(?:.[0-9]+)?$ |
body.GlobalTaxCalculation | string | Optional | Method in which tax is applied. Allowed values are: TaxExcluded , TaxInclusive , and NotApplicable . Not applicable to US companies; required for non-US companies. Conditionally required |
body.HomeBalance | JSON | Optional | Convenience field containing the amount in Balance expressed in terms of the home currency. Calculated by QuickBooks business logic. Value is valid only when CurrencyRef is specified. Applicable if multicurrency is enabled for the company. Decimal string Read only: true |
body.HomeBalance (anyOf 1) | number | Alternative | |
body.HomeBalance (anyOf 2) | string | Alternative | Pattern: ^-?[0-9]+(?:.[0-9]+)?$ |
body.HomeTotalAmt | JSON | Optional | Total amount of the transaction in the home currency. Includes the total of all the charges, allowances and taxes. Calculated by QuickBooks business logic. Value is valid only when CurrencyRef is specified. Applicable if multicurrency is enabled for the company. Decimal string Read only: true |
body.HomeTotalAmt (anyOf 1) | number | Alternative | |
body.HomeTotalAmt (anyOf 2) | string | Alternative | Pattern: ^-?[0-9]+(?:.[0-9]+)?$ |
body.Id | string | Required within parent | |
body.Line | array | Optional | Individual line items of a transaction. Valid Line types include: SalesItemLine , GroupLine , DescriptionOnlyLine , DiscountLine and SubTotalLine |
body.Line[] | JSON | Each item | |
body.Line[] (anyOf 1) | Model | Alternative | Expand Create a change order — request body — body Line item |
body.Line[] (anyOf 2) | Model | Alternative | Expand Void an invoice — request body — body Line item Custom Extensions, Description, Detail Type, Group Line Detail, Id, Line Num |
body.Line[] (anyOf 3) | Model | Alternative | Expand Void an invoice — request body — body Line item Amount, Description, Description Line Detail, Detail Type, Id, Line Num |
body.Line[] (anyOf 4) | Model | Alternative | Expand Void an invoice — request body — body Line item Amount, Description, Detail Type, Discount Line Detail, Id, Line Num |
body.Line[] (anyOf 5) | Model | Alternative | Expand Void an invoice — request body — body Line item Amount, Description, Detail Type, Id, Line Num, Sub Total Line Detail |
body.MetaData | Model | Optional | Expand Read a bill — response body — Bill Meta Data Descriptive information about the object. The MetaData values are set by Data Services and are read only for all applications. |
body.PaymentMethodRef | Model | Optional | Expand Create a purchase order — request body — body Ship To Reference to a PaymentMethod associated with this transaction. Query the PaymentMethod name list resource to determine the appropriate PaymentMethod object for this reference. Use PaymentMethod.Id and PaymentMethod.Name from that object for PaymentMethodRef.value and PaymentMethodRef.name , respectively. Read only: true |
body.PrintStatus | string | Optional | Printing status of the credit-memo. Valid values: NotSet , NeedToPrint , PrintComplete . |
body.PrivateNote | string | Optional | User entered, organization-private note about the transaction. This note does not appear on the deposit form. |
body.ProjectRef | Model | Optional | Expand Create a purchase order — request body — body Ship To Reference to the Project ID associated with this transaction. Conditionally required |
body.RecurDataRef | Model | Optional | Expand Create a purchase order — request body — body Ship To A reference to the Recurring Transaction. It captures what recurring transaction template the CreditMemo was created from. Read only: true |
body.RemainingCredit | JSON | Optional | Indicates the total credit amount still available to apply towards the payment. Decimal string Read only: true |
body.RemainingCredit (anyOf 1) | number | Alternative | |
body.RemainingCredit (anyOf 2) | string | Alternative | Pattern: ^-?[0-9]+(?:.[0-9]+)?$ |
body.SalesTermRef | Model | Optional | Expand Create a purchase order — request body — body Ship To Reference to the sales term associated with the transaction. Query the Term name list resource to determine the appropriate Term object for this reference. Use Term.Id and Term.Name from that object for SalesTermRef.value and SalesTermRef.name , respectively. |
body.ShipAddr | Model | Optional | Expand Create a vendor — request body — body Bill Addr Identifies the address where the goods must be shipped. If ShipAddr is not specified, and a default Customer:ShippingAddr is specified in QuickBooks for this customer, the default ship-to address will be used by QuickBooks. For international addresses - countries should be passed as 3 ISO alpha-3 characters or the full name of the country. If a physical address is updated from within the transaction object, the QuickBooks Online API flows individual address components differently into the Line elements of the transaction response then when the transaction was first created: Line1 and Line2 elements are populated with the customer name and company name. Original Line1 through Line 5 contents, City , SubDivisionCode , and PostalCode flow into Line3 through Line5 as a free format strings. |
body.SyncToken | string | Required within parent | |
body.TaxExemptionRef | Model | Optional | Expand Create a purchase order — request body — body Ship To Reference to the TaxExepmtion ID associated with this object. Available for companies that have automated sales tax enabled. TaxExemptionRef.Name : The Tax Exemption Id for the customer to which this object is associated. This Id is typically issued by the state. TaxExemptionRef.value : The system-generated Id of the exemption type. For internal use only. Read only: true |
body.TotalAmt | JSON | Optional | Indicates the total amount of the transaction. This includes the total of all the charges, allowances, and taxes. Calculated by QuickBooks business logic; any value you supply is over-written by QuickBooks. Decimal string |
body.TotalAmt (anyOf 1) | number | Alternative | |
body.TotalAmt (anyOf 2) | string | Alternative | Pattern: ^-?[0-9]+(?:.[0-9]+)?$ |
body.TxnDate | string | Optional | The date entered by the user when this transaction occurred. For posting transactions, this is the posting date that affects the financial statements. If the date is not supplied, the current date on the server is used. Sort order is ASC by default. |
body.TxnTaxDetail | Model | Optional | Expand Create a bill — request body — body Txn Tax Detail This data type provides information for taxes charged on the transaction as a whole. It captures the details sales taxes calculated for the transaction based on the tax codes referenced by the transaction. This can be calculated by QuickBooks business logic or you may supply it when adding a transaction. See Global tax model for more information about this element. If sales tax is disabled ( Preferences.TaxPrefs.UsingSalesTax is set to false ) then TxnTaxDetail is ignored and not stored. |
body.domain | string | Optional | |
body.sparse | boolean | Optional | Must equal: false |
Referenced models: Full update companyinfo — request body — body Email, Read a bill — response body — Bill Meta Data, Create a vendor — request body — body Bill Addr, Create a bill — request body — body Currency Ref, Void an invoice — request body — body Custom Field item, Void an invoice — request body — body Line item Amount, Description, Description Line Detail, Detail Type, Id, Line Num, Void an invoice — request body — body Line item Amount, Description, Detail Type, Discount Line Detail, Id, Line Num, Void an invoice — request body — body Line item Custom Extensions, Description, Detail Type, Group Line Detail, Id, Line Num, Void an invoice — request body — body Customer Memo, Create a purchase order — request body — body Ship To, Create a change order — request body — body Line item, Void an invoice — request body — body Line item Amount, Description, Detail Type, Id, Line Num, Sub Total Line Detail, Create a bill — request body — body Txn Tax Detail
Response
Section titled “Response”Response media type: application/json. The table describes the pinned successful response. Referenced models link to their complete fields.
| Field | Type | Presence | Description and constraints |
|---|---|---|---|
$ | object | Root | Additional keys: allowed |
time | string | Optional | |
CreditMemo | Model | Optional | Expand Read a credit memo — response body — Credit Memo |
Referenced models: Read a credit memo — response body — Credit Memo
Policy, approvals and errors
Section titled “Policy, approvals and errors”SDK function policy ID: quickbooks.creditmemo.full_update_a_credit_memo. Catalog operation: creditmemo/create_a_credit_memo. Rules can name either ID; function rules distinguish managed calls and conservatively cover raw calls sharing the route. Existing grant permissions and policy rules apply. wait() returns an immediate result or waits for a required approval; it never approves the request itself. Persist the approval ID to resume after a restart.
Provider errors retain their response; JSON decoding raises ProviderAPIError for provider failures. ManagedOperationError identifies contract/input/retention errors. See error handling and provider-specific behavior. Sensitive input may be refused before approval storage. A decoding error never resubmits a write.